/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include <stdio.h>
#include <math.h>
#include <string>
#include <fstream>
#include <list>
#include <iostream>
#include "colour_definition.h"

using std::cerr;
using std::endl;
using std::ifstream;
using std::string;

#define CUBE_SIZE 128

int getH(int u, int v) {
    return (int) atan2(u-64, v-64);
}

int getS(int u, int v) {
    return (int) sqrt((u-64)*(u-64) + (v-64)*(v-64));
}    

unsigned char tree(int y, int u, int v) {
    // copy and paste c4.5 output here
    
if (u <= 77)
{
    if (v <= 62)
    {
        if (u <= 64)
        {
            if (v <= 56)
            {
                if (y <= 70)
                {
                    if (y <= 65)
                    {
                        if (v <= 55)
                        {
                            if (v > 46)
                            {
                            	return 7;
                            }
                            else
                            {
                                if (v <= 41)
                                {
                                	return 8;
                                }
                                else
                                {
                                	return 7;
                                }
                            }
                        }
                        else
                        {
                            if (y <= 52)
                            {
                                if (u <= 56)
                                {
                                	return 2;
                                }
                                else
                                {
                                	return 7;
                                }
                            }
                            else
                            {
                                if (u <= 59)
                                {
                                	return 2;
                                }
                                else
                                {
                                	return 7;
                                }
                            }
                        }
                    }
                    else
                    {
                        if (v <= 54)
                        {
                            if (v <= 51)
                            {
                            	return 7;
                            }
                            else
                            {
                                if (u <= 63)
                                {
                                	return 7;
                                }
                                else
                                {
                                    if (y <= 68)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                    	return 9;
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v > 55)
                            {
                            	return 2;
                            }
                            else
                            {
                                if (y <= 66)
                                {
                                	return 7;
                                }
                                else
                                {
                                	return 2;
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (v <= 51)
                    {
                        if (y <= 73)
                        {
                        	return 7;
                        }
                        else
                        {
                        	return 9;
                        }
                    }
                    else
                    {
                        if (u <= 60)
                        {
                        	return 2;
                        }
                        else
                        {
                        	return 9;
                        }
                    }
                }
            }
            else
            {
                if (y <= 41)
                {
                    if (u <= 57)
                    {
                        if (u <= 56)
                        {
                        	return 2;
                        }
                        else
                        {
                            if (v <= 58)
                            {
                            	return 7;
                            }
                            else
                            {
                                if (y <= 32)
                                {
                                	return 7;
                                }
                                else
                                {
                                	return 2;
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y <= 15)
                        {
                            if (y <= 10)
                            {
                            	return 10;
                            }
                            else
                            {
                            	return 8;
                            }
                        }
                        else
                        {
                            if (u <= 63)
                            {
                                if (v <= 61)
                                {
                                	return 7;
                                }
                                else
                                {
                                    if (y <= 27)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (u <= 62)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                        	return 8;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 58)
                                {
                                    if (y <= 20)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                    	return 7;
                                    }
                                }
                                else
                                {
                                    if (y <= 31)
                                    {
                                        if (y <= 18)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 61)
                                            {
                                                if (v <= 60)
                                                {
                                                    if (y <= 20)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 7;
                                                    }
                                                }
                                                else
                                                {
                                                    if (y <= 28)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                if (y <= 20)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                	return 8;
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (v > 59)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y > 38)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (y <= 35)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 7;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (y <= 64)
                    {
                        if (u <= 59)
                        {
                            if (u <= 58)
                            {
                            	return 2;
                            }
                            else
                            {
                                if (y > 48)
                                {
                                	return 2;
                                }
                                else
                                {
                                    if (v <= 58)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                    	return 2;
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 51)
                            {
                                if (v <= 60)
                                {
                                    if (u <= 61)
                                    {
                                        if (y <= 48)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (v > 58)
                                            {
                                            	return 2;
                                            }
                                            else
                                            {
                                                if (u > 60)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                    if (y <= 49)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 2;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 63)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (v <= 58)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                                if (v <= 59)
                                                {
                                                    if (y <= 49)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 2;
                                                    }
                                                }
                                                else
                                                {
                                                    if (y <= 48)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (u > 60)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (y <= 45)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (v <= 61)
                                            {
                                            	return 2;
                                            }
                                            else
                                            {
                                                if (y <= 48)
                                                {
                                                	return 2;
                                                }
                                                else
                                                {
                                                	return 8;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 57)
                                {
                                    if (y <= 56)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (u <= 63)
                                        {
                                        	return 2;
                                        }
                                        else
                                        {
                                        	return 7;
                                        }
                                    }
                                }
                                else
                                {
                                    if (u <= 62)
                                    {
                                        if (v <= 61)
                                        {
                                        	return 2;
                                        }
                                        else
                                        {
                                            if (y <= 60)
                                            {
                                            	return 2;
                                            }
                                            else
                                            {
                                            	return 1;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 63)
                                        {
                                        	return 2;
                                        }
                                        else
                                        {
                                            if (v <= 58)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y <= 85)
                        {
                            if (u <= 62)
                            {
                                if (v <= 59)
                                {
                                	return 2;
                                }
                                else
                                {
                                    if (v > 60)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (y <= 68)
                                        {
                                        	return 1;
                                        }
                                        else
                                        {
                                        	return 2;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v > 59)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (v <= 57)
                                    {
                                        if (y <= 68)
                                        {
                                        	return 2;
                                        }
                                        else
                                        {
                                        	return 9;
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 63)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (y <= 65)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v <= 61)
                            {
                            	return 9;
                            }
                            else
                            {
                                if (y > 121)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (y > 96)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (y <= 90)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                        	return 8;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        else
        {
            if (y <= 59)
            {
                if (u <= 72)
                {
                    if (v <= 55)
                    {
                        if (y <= 51)
                        {
                            if (v <= 52)
                            {
                                if (u <= 71)
                                {
                                	return 7;
                                }
                                else
                                {
                                	return 8;
                                }
                            }
                            else
                            {
                                if (u <= 67)
                                {
                                    if (y <= 42)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (u <= 66)
                                        {
                                            if (v <= 54)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                                if (u <= 65)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                    if (y > 48)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 44)
                                                        {
                                                        	return 7;
                                                        }
                                                        else
                                                        {
                                                        	return 8;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if (v > 54)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (y <= 48)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                	return 8;
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (v <= 53)
                                    {
                                        if (y <= 39)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (u > 69)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u <= 68)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                    if (y <= 47)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (y <= 39)
                                        {
                                            if (u > 69)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (v <= 54)
                                                {
                                                    if (u <= 68)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 37)
                                                        {
                                                        	return 7;
                                                        }
                                                        else
                                                        {
                                                        	return 8;
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (y <= 31)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if (y <= 49)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u > 69)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (v <= 54)
                                                    {
                                                    	return 9;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (u <= 67)
                            {
                                if (u <= 66)
                                {
                                	return 7;
                                }
                                else
                                {
                                    if (v > 52)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (v <= 51)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (y <= 57)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                            	return 9;
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 51)
                                {
                                    if (y <= 54)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (v <= 49)
                                        {
                                            if (u <= 68)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                        else
                                        {
                                            if (y > 55)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (v <= 50)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                	return 9;
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (u <= 70)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (u <= 71)
                                        {
                                            if (v <= 52)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (y <= 58)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 9;
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if (v <= 53)
                                            {
                                                if (v <= 52)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 9;
                                                }
                                            }
                                            else
                                            {
                                                if (y > 54)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (y <= 53)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 2;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (v <= 60)
                        {
                            if (u <= 66)
                            {
                                if (v <= 57)
                                {
                                    if (u <= 65)
                                    {
                                        if (y <= 43)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (y <= 54)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                            	return 7;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (y > 41)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 56)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                                if (y > 29)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (y <= 25)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 7;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (v > 58)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (u > 65)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y > 31)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (y <= 22)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 7;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (y <= 33)
                                {
                                    if (u <= 70)
                                    {
                                        if (v > 57)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u > 68)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (v <= 56)
                                                {
                                                    if (y <= 31)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                                else
                                                {
                                                    if (u > 67)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 24)
                                                        {
                                                        	return 8;
                                                        }
                                                        else
                                                        {
                                                            if (y <= 29)
                                                            {
                                                            	return 7;
                                                            }
                                                            else
                                                            {
                                                            	return 8;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (y > 25)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 57)
                                            {
                                                if (u <= 71)
                                                {
                                                	return 5;
                                                }
                                                else
                                                {
                                                	return 6;
                                                }
                                            }
                                            else
                                            {
                                                if (y <= 18)
                                                {
                                                	return 6;
                                                }
                                                else
                                                {
                                                    if (u > 71)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 22)
                                                        {
                                                        	return 6;
                                                        }
                                                        else
                                                        {
                                                        	return 8;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (y <= 52)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (v > 56)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u > 70)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (y > 54)
                                                {
                                                	return 9;
                                                }
                                                else
                                                {
                                                    if (u > 68)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (u <= 67)
                                                        {
                                                        	return 8;
                                                        }
                                                        else
                                                        {
                                                        	return 9;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 26)
                            {
                                if (y <= 11)
                                {
                                	return 10;
                                }
                                else
                                {
                                    if (u <= 68)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (y <= 18)
                                        {
                                        	return 6;
                                        }
                                        else
                                        {
                                            if (u <= 70)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u <= 71)
                                                {
                                                    if (y <= 23)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 6;
                                                    }
                                                }
                                                else
                                                {
                                                    if (v <= 61)
                                                    {
                                                    	return 6;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (y > 48)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (v <= 61)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (u <= 66)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y <= 34)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u > 67)
                                                {
                                                	return 5;
                                                }
                                                else
                                                {
                                                    if (y <= 38)
                                                    {
                                                    	return 5;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 43)
                                                        {
                                                        	return 8;
                                                        }
                                                        else
                                                        {
                                                        	return 5;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (v <= 51)
                    {
                        if (v <= 49)
                        {
                            if (y <= 44)
                            {
                            	return 3;
                            }
                            else
                            {
                                if (v <= 47)
                                {
                                	return 3;
                                }
                                else
                                {
                                	return 0;
                                }
                            }
                        }
                        else
                        {
                            if (y > 48)
                            {
                            	return 8;
                            }
                            else
                            {
                                if (v <= 50)
                                {
                                    if (y <= 39)
                                    {
                                    	return 3;
                                    }
                                    else
                                    {
                                    	return 0;
                                    }
                                }
                                else
                                {
                                    if (y <= 36)
                                    {
                                    	return 3;
                                    }
                                    else
                                    {
                                    	return 0;
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y <= 33)
                        {
                            if (y <= 22)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (u <= 74)
                                {
                                    if (v > 60)
                                    {
                                    	return 6;
                                    }
                                    else
                                    {
                                        if (u <= 73)
                                        {
                                            if (v <= 55)
                                            {
                                            	return 6;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                        else
                                        {
                                            if (y <= 27)
                                            {
                                            	return 6;
                                            }
                                            else
                                            {
                                                if (v <= 57)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (y <= 30)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 6;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (v <= 55)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                    	return 6;
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v <= 53)
                            {
                                if (y <= 37)
                                {
                                	return 0;
                                }
                                else
                                {
                                	return 8;
                                }
                            }
                            else
                            {
                                if (v <= 58)
                                {
                                    if (u <= 76)
                                    {
                                        if (y > 47)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 73)
                                            {
                                                if (y <= 46)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 6;
                                                }
                                            }
                                            else
                                            {
                                                if (u <= 75)
                                                {
                                                    if (v <= 56)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (u > 74)
                                                        {
                                                        	return 6;
                                                        }
                                                        else
                                                        {
                                                            if (v <= 57)
                                                            {
                                                            	return 8;
                                                            }
                                                            else
                                                            {
                                                            	return 6;
                                                            }
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (v <= 54)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 6;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 54)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y <= 43)
                                            {
                                            	return 6;
                                            }
                                            else
                                            {
                                                if (v <= 57)
                                                {
                                                	return 6;
                                                }
                                                else
                                                {
                                                	return 5;
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (v <= 61)
                                    {
                                        if (y > 50)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 73)
                                            {
                                            	return 5;
                                            }
                                            else
                                            {
                                                if (y <= 37)
                                                {
                                                    if (u <= 74)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (u <= 76)
                                                        {
                                                        	return 6;
                                                        }
                                                        else
                                                        {
                                                        	return 8;
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (u <= 75)
                                                    {
                                                        if (v <= 59)
                                                        {
                                                        	return 8;
                                                        }
                                                        else
                                                        {
                                                        	return 6;
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if (u > 76)
                                                        {
                                                        	return 6;
                                                        }
                                                        else
                                                        {
                                                            if (v <= 60)
                                                            {
                                                            	return 6;
                                                            }
                                                            else
                                                            {
                                                            	return 5;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 74)
                                        {
                                        	return 5;
                                        }
                                        else
                                        {
                                        	return 6;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if (v <= 54)
                {
                    if (y <= 68)
                    {
                        if (u <= 68)
                        {
                            if (v <= 51)
                            {
                                if (y <= 66)
                                {
                                    if (u <= 66)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (v <= 49)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (u <= 67)
                                            {
                                                if (y <= 63)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                    if (v <= 50)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 9;
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                if (y <= 60)
                                                {
                                                	return 7;
                                                }
                                                else
                                                {
                                                	return 9;
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (u <= 65)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (u > 66)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (v <= 48)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                            	return 9;
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (u > 66)
                                {
                                	return 9;
                                }
                                else
                                {
                                    if (y > 65)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (u <= 65)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (y <= 61)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                                if (v > 53)
                                                {
                                                	return 9;
                                                }
                                                else
                                                {
                                                    if (y <= 64)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 9;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v <= 43)
                            {
                            	return 3;
                            }
                            else
                            {
                                if (u <= 73)
                                {
                                	return 9;
                                }
                                else
                                {
                                    if (v <= 49)
                                    {
                                        if (y <= 60)
                                        {
                                        	return 3;
                                        }
                                        else
                                        {
                                        	return 9;
                                        }
                                    }
                                    else
                                    {
                                        if (y <= 62)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 50)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (u <= 73)
                        {
                        	return 9;
                        }
                        else
                        {
                            if (v <= 50)
                            {
                                if (v <= 36)
                                {
                                	return 3;
                                }
                                else
                                {
                                    if (y <= 77)
                                    {
                                        if (v > 44)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (v > 41)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (y <= 76)
                                                {
                                                	return 3;
                                                }
                                                else
                                                {
                                                	return 9;
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 47)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (u <= 75)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (y <= 85)
                                                {
                                                	return 9;
                                                }
                                                else
                                                {
                                                    if (y <= 98)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                    	return 9;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 52)
                                {
                                    if (u <= 75)
                                    {
                                        if (y <= 82)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (u <= 74)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (y > 83)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 76)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (v > 51)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (y <= 73)
                                                    {
                                                    	return 9;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (y <= 82)
                                    {
                                        if (u > 74)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 53)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 76)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                        	return 4;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (u <= 70)
                    {
                        if (v <= 58)
                        {
                            if (u <= 68)
                            {
                                if (y > 65)
                                {
                                	return 9;
                                }
                                else
                                {
                                    if (v <= 56)
                                    {
                                        if (u > 65)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (y <= 60)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                            	return 9;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (y <= 61)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                        	return 9;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 56)
                                {
                                    if (v <= 55)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (u <= 69)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (y <= 65)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (u > 69)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (v <= 57)
                                        {
                                            if (y <= 62)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                        else
                                        {
                                            if (y <= 108)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                            	return 9;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 99)
                            {
                                if (y <= 62)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (u > 66)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (v > 61)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 65)
                                            {
                                                if (y > 83)
                                                {
                                                	return 9;
                                                }
                                                else
                                                {
                                                    if (v > 59)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 74)
                                                        {
                                                        	return 9;
                                                        }
                                                        else
                                                        {
                                                        	return 8;
                                                        }
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                if (y <= 65)
                                                {
                                                	return 9;
                                                }
                                                else
                                                {
                                                	return 8;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (u > 66)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (v <= 61)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                    	return 8;
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (u <= 75)
                        {
                            if (v > 55)
                            {
                            	return 8;
                            }
                            else
                            {
                                if (u > 72)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (y <= 65)
                                    {
                                    	return 9;
                                    }
                                    else
                                    {
                                        if (u > 71)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y <= 70)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 79)
                            {
                            	return 8;
                            }
                            else
                            {
                                if (y > 101)
                                {
                                	return 4;
                                }
                                else
                                {
                                    if (y <= 89)
                                    {
                                    	return 4;
                                    }
                                    else
                                    {
                                    	return 8;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    else
    {
        if (u <= 60)
        {
            if (v <= 65)
            {
                if (y <= 44)
                {
                    if (u <= 56)
                    {
                        if (v <= 64)
                        {
                        	return 2;
                        }
                        else
                        {
                            if (u <= 53)
                            {
                            	return 2;
                            }
                            else
                            {
                                if (u <= 55)
                                {
                                	return 1;
                                }
                                else
                                {
                                    if (y > 37)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (y <= 29)
                                        {
                                        	return 1;
                                        }
                                        else
                                        {
                                        	return 7;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y <= 27)
                        {
                            if (y <= 21)
                            {
                            	return 5;
                            }
                            else
                            {
                                if (v <= 64)
                                {
                                	return 7;
                                }
                                else
                                {
                                	return 1;
                                }
                            }
                        }
                        else
                        {
                            if (v <= 64)
                            {
                            	return 7;
                            }
                            else
                            {
                                if (y <= 39)
                                {
                                	return 7;
                                }
                                else
                                {
                                    if (y <= 41)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (u <= 58)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                        	return 1;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (v <= 63)
                    {
                        if (y <= 59)
                        {
                        	return 2;
                        }
                        else
                        {
                        	return 1;
                        }
                    }
                    else
                    {
                        if (y > 57)
                        {
                        	return 1;
                        }
                        else
                        {
                            if (v > 64)
                            {
                            	return 1;
                            }
                            else
                            {
                                if (y <= 51)
                                {
                                	return 2;
                                }
                                else
                                {
                                    if (y <= 53)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (y > 56)
                                        {
                                        	return 1;
                                        }
                                        else
                                        {
                                            if (u <= 57)
                                            {
                                            	return 1;
                                            }
                                            else
                                            {
                                            	return 2;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if (v <= 66)
                {
                    if (y > 41)
                    {
                    	return 1;
                    }
                    else
                    {
                        if (y <= 30)
                        {
                        	return 1;
                        }
                        else
                        {
                            if (u <= 55)
                            {
                                if (u <= 53)
                                {
                                	return 2;
                                }
                                else
                                {
                                    if (y <= 36)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (y <= 38)
                                        {
                                        	return 2;
                                        }
                                        else
                                        {
                                        	return 1;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (u <= 56)
                                {
                                	return 1;
                                }
                                else
                                {
                                    if (u <= 57)
                                    {
                                    	return 7;
                                    }
                                    else
                                    {
                                        if (y <= 38)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                        	return 1;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (u <= 57)
                    {
                        if (v <= 75)
                        {
                        	return 1;
                        }
                        else
                        {
                            if (v <= 78)
                            {
                            	return 1;
                            }
                            else
                            {
                            	return 8;
                            }
                        }
                    }
                    else
                    {
                        if (v <= 73)
                        {
                        	return 1;
                        }
                        else
                        {
                        	return 5;
                        }
                    }
                }
            }
        }
        else
        {
            if (u <= 66)
            {
                if (y <= 49)
                {
                    if (y <= 13)
                    {
                        if (y <= 11)
                        {
                        	return 10;
                        }
                        else
                        {
                            if (u <= 62)
                            {
                                if (y <= 12)
                                {
                                	return 5;
                                }
                                else
                                {
                                	return 8;
                                }
                            }
                            else
                            {
                                if (u > 64)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (v > 65)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (y <= 12)
                                        {
                                        	return 10;
                                        }
                                        else
                                        {
                                        	return 8;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (v <= 64)
                        {
                            if (u <= 63)
                            {
                                if (y > 25)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (y <= 15)
                                    {
                                        if (u > 62)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (v <= 63)
                                            {
                                            	return 10;
                                            }
                                            else
                                            {
                                            	return 5;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (u <= 61)
                                        {
                                        	return 7;
                                        }
                                        else
                                        {
                                            if (y <= 21)
                                            {
                                            	return 7;
                                            }
                                            else
                                            {
                                                if (v > 63)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (u <= 62)
                                                    {
                                                    	return 7;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (u <= 64)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (y <= 17)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (v > 63)
                                        {
                                        	return 5;
                                        }
                                        else
                                        {
                                            if (y <= 25)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u <= 65)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 5;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (u <= 63)
                            {
                                if (y <= 19)
                                {
                                	return 5;
                                }
                                else
                                {
                                    if (v > 66)
                                    {
                                    	return 5;
                                    }
                                    else
                                    {
                                        if (v <= 65)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 61)
                                            {
                                                if (y > 23)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                    if (y <= 21)
                                                    {
                                                    	return 1;
                                                    }
                                                    else
                                                    {
                                                    	return 5;
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                if (u <= 62)
                                                {
                                                    if (y <= 22)
                                                    {
                                                    	return 5;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                                else
                                                {
                                                    if (y <= 25)
                                                    {
                                                    	return 8;
                                                    }
                                                    else
                                                    {
                                                        if (y <= 32)
                                                        {
                                                        	return 5;
                                                        }
                                                        else
                                                        {
                                                            if (y <= 44)
                                                            {
                                                            	return 8;
                                                            }
                                                            else
                                                            {
                                                            	return 5;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (v > 66)
                                {
                                	return 5;
                                }
                                else
                                {
                                    if (y <= 14)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                    	return 5;
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (y > 70)
                    {
                    	return 8;
                    }
                    else
                    {
                        if (u <= 62)
                        {
                            if (y > 59)
                            {
                            	return 1;
                            }
                            else
                            {
                                if (v > 65)
                                {
                                	return 1;
                                }
                                else
                                {
                                    if (y <= 52)
                                    {
                                        if (y <= 50)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                        	return 1;
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 63)
                                        {
                                            if (y <= 54)
                                            {
                                            	return 2;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                        else
                                        {
                                            if (v <= 64)
                                            {
                                            	return 1;
                                            }
                                            else
                                            {
                                            	return 2;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v <= 64)
                            {
                                if (y <= 60)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (u <= 63)
                                    {
                                        if (y <= 65)
                                        {
                                        	return 1;
                                        }
                                        else
                                        {
                                        	return 8;
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 63)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (y <= 65)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                            	return 1;
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (y <= 56)
                                {
                                	return 5;
                                }
                                else
                                {
                                    if (v > 65)
                                    {
                                    	return 1;
                                    }
                                    else
                                    {
                                        if (u > 65)
                                        {
                                        	return 1;
                                        }
                                        else
                                        {
                                            if (y <= 61)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (y <= 64)
                                                {
                                                	return 1;
                                                }
                                                else
                                                {
                                                    if (u <= 64)
                                                    {
                                                    	return 1;
                                                    }
                                                    else
                                                    {
                                                    	return 8;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if (y <= 21)
                {
                    if (u <= 68)
                    {
                        if (y <= 15)
                        {
                            if (u > 67)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (v <= 65)
                                {
                                	return 8;
                                }
                                else
                                {
                                	return 6;
                                }
                            }
                        }
                        else
                        {
                            if (v > 65)
                            {
                            	return 5;
                            }
                            else
                            {
                                if (v <= 63)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (y <= 16)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                        if (u <= 67)
                                        {
                                        	return 5;
                                        }
                                        else
                                        {
                                            if (y <= 19)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                            	return 5;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y <= 19)
                        {
                        	return 6;
                        }
                        else
                        {
                            if (u <= 72)
                            {
                            	return 8;
                            }
                            else
                            {
                            	return 6;
                            }
                        }
                    }
                }
                else
                {
                    if (y <= 53)
                    {
                        if (u <= 72)
                        {
                            if (v > 63)
                            {
                            	return 5;
                            }
                            else
                            {
                                if (y <= 25)
                                {
                                    if (u <= 67)
                                    {
                                    	return 5;
                                    }
                                    else
                                    {
                                        if (u <= 70)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                        	return 6;
                                        }
                                    }
                                }
                                else
                                {
                                    if (y <= 49)
                                    {
                                    	return 5;
                                    }
                                    else
                                    {
                                    	return 8;
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 30)
                            {
                            	return 6;
                            }
                            else
                            {
                            	return 5;
                            }
                        }
                    }
                    else
                    {
                        if (y > 70)
                        {
                        	return 8;
                        }
                        else
                        {
                            if (u > 67)
                            {
                            	return 1;
                            }
                            else
                            {
                                if (v > 63)
                                {
                                	return 1;
                                }
                                else
                                {
                                    if (y <= 59)
                                    {
                                    	return 2;
                                    }
                                    else
                                    {
                                    	return 5;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
else
{
    if (v <= 52)
    {
        if (v <= 36)
        {
            if (u <= 89)
            {
                if (y <= 92)
                {
                	return 3;
                }
                else
                {
                    if (u <= 86)
                    {
                    	return 3;
                    }
                    else
                    {
                    	return 0;
                    }
                }
            }
            else
            {
                if (y > 79)
                {
                	return 0;
                }
                else
                {
                    if (u <= 95)
                    {
                    	return 3;
                    }
                    else
                    {
                    	return 0;
                    }
                }
            }
        }
        else
        {
            if (u <= 83)
            {
                if (v <= 44)
                {
                    if (y <= 80)
                    {
                        if (v <= 42)
                        {
                            if (y <= 76)
                            {
                            	return 3;
                            }
                            else
                            {
                                if (v <= 39)
                                {
                                	return 3;
                                }
                                else
                                {
                                    if (y > 79)
                                    {
                                    	return 3;
                                    }
                                    else
                                    {
                                        if (y <= 77)
                                        {
                                        	return 3;
                                        }
                                        else
                                        {
                                        	return 9;
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (u > 81)
                            {
                            	return 0;
                            }
                            else
                            {
                                if (y <= 67)
                                {
                                	return 3;
                                }
                                else
                                {
                                	return 9;
                                }
                            }
                        }
                    }
                    else
                    {
                        if (u <= 79)
                        {
                        	return 9;
                        }
                        else
                        {
                            if (y > 86)
                            {
                            	return 8;
                            }
                            else
                            {
                                if (v <= 41)
                                {
                                	return 3;
                                }
                                else
                                {
                                	return 0;
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (y <= 55)
                    {
                        if (u <= 79)
                        {
                            if (v <= 47)
                            {
                                if (y <= 46)
                                {
                                	return 3;
                                }
                                else
                                {
                                	return 0;
                                }
                            }
                            else
                            {
                                if (v > 49)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (y <= 41)
                                    {
                                    	return 3;
                                    }
                                    else
                                    {
                                    	return 0;
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v <= 46)
                            {
                                if (y > 46)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (u <= 80)
                                    {
                                    	return 3;
                                    }
                                    else
                                    {
                                    	return 0;
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 50)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (y <= 47)
                                    {
                                    	return 0;
                                    }
                                    else
                                    {
                                        if (y <= 48)
                                        {
                                        	return 6;
                                        }
                                        else
                                        {
                                        	return 8;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (y > 84)
                        {
                        	return 8;
                        }
                        else
                        {
                            if (u <= 79)
                            {
                                if (y <= 67)
                                {
                                	return 8;
                                }
                                else
                                {
                                    if (v <= 49)
                                    {
                                        if (u <= 78)
                                        {
                                        	return 9;
                                        }
                                        else
                                        {
                                            if (v > 48)
                                            {
                                            	return 9;
                                            }
                                            else
                                            {
                                                if (y <= 79)
                                                {
                                                	return 8;
                                                }
                                                else
                                                {
                                                	return 0;
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 51)
                                        {
                                            if (y > 79)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                                if (u > 78)
                                                {
                                                	return 4;
                                                }
                                                else
                                                {
                                                    if (y <= 73)
                                                    {
                                                    	return 9;
                                                    }
                                                    else
                                                    {
                                                    	return 4;
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if (y <= 81)
                                            {
                                            	return 8;
                                            }
                                            else
                                            {
                                            	return 4;
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (u <= 80)
                                {
                                    if (v <= 47)
                                    {
                                    	return 0;
                                    }
                                    else
                                    {
                                    	return 8;
                                    }
                                }
                                else
                                {
                                    if (y <= 71)
                                    {
                                        if (y > 64)
                                        {
                                        	return 8;
                                        }
                                        else
                                        {
                                            if (u <= 81)
                                            {
                                            	return 6;
                                            }
                                            else
                                            {
                                            	return 0;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (v <= 48)
                                        {
                                            if (y <= 82)
                                            {
                                            	return 0;
                                            }
                                            else
                                            {
                                            	return 8;
                                            }
                                        }
                                        else
                                        {
                                            if (u <= 82)
                                            {
                                                if (y <= 76)
                                                {
                                                	return 4;
                                                }
                                                else
                                                {
                                                	return 8;
                                                }
                                            }
                                            else
                                            {
                                                if (y <= 77)
                                                {
                                                	return 4;
                                                }
                                                else
                                                {
                                                	return 0;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if (v <= 39)
                {
                    if (u <= 86)
                    {
                        if (y <= 79)
                        {
                        	return 3;
                        }
                        else
                        {
                        	return 0;
                        }
                    }
                    else
                    {
                        if (y > 73)
                        {
                        	return 0;
                        }
                        else
                        {
                            if (v > 37)
                            {
                            	return 0;
                            }
                            else
                            {
                                if (u <= 95)
                                {
                                	return 3;
                                }
                                else
                                {
                                	return 0;
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (v <= 49)
                    {
                    	return 0;
                    }
                    else
                    {
                        if (y <= 69)
                        {
                            if (u <= 94)
                            {
                            	return 0;
                            }
                            else
                            {
                                if (y > 58)
                                {
                                	return 6;
                                }
                                else
                                {
                                    if (v <= 51)
                                    {
                                    	return 0;
                                    }
                                    else
                                    {
                                        if (y <= 49)
                                        {
                                        	return 0;
                                        }
                                        else
                                        {
                                        	return 6;
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (v > 50)
                            {
                            	return 4;
                            }
                            else
                            {
                                if (y <= 74)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (y > 77)
                                    {
                                    	return 4;
                                    }
                                    else
                                    {
                                        if (y <= 76)
                                        {
                                        	return 4;
                                        }
                                        else
                                        {
                                        	return 0;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    else
    {
        if (y <= 59)
        {
            if (v <= 56)
            {
                if (u <= 90)
                {
                    if (y <= 41)
                    {
                        if (v <= 54)
                        {
                        	return 0;
                        }
                        else
                        {
                            if (u <= 78)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (v <= 55)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (u > 87)
                                    {
                                    	return 6;
                                    }
                                    else
                                    {
                                        if (y <= 28)
                                        {
                                        	return 6;
                                        }
                                        else
                                        {
                                            if (y <= 39)
                                            {
                                            	return 0;
                                            }
                                            else
                                            {
                                            	return 6;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (v > 54)
                        {
                        	return 6;
                        }
                        else
                        {
                            if (u <= 81)
                            {
                                if (y <= 42)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (u <= 78)
                                    {
                                    	return 8;
                                    }
                                    else
                                    {
                                    	return 6;
                                    }
                                }
                            }
                            else
                            {
                                if (v <= 53)
                                {
                                	return 0;
                                }
                                else
                                {
                                    if (y <= 55)
                                    {
                                    	return 0;
                                    }
                                    else
                                    {
                                    	return 6;
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (y > 46)
                    {
                    	return 6;
                    }
                    else
                    {
                        if (v <= 53)
                        {
                        	return 0;
                        }
                        else
                        {
                            if (v > 55)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (u > 93)
                                {
                                	return 6;
                                }
                                else
                                {
                                    if (y > 45)
                                    {
                                    	return 6;
                                    }
                                    else
                                    {
                                        if (u <= 92)
                                        {
                                        	return 0;
                                        }
                                        else
                                        {
                                            if (v <= 54)
                                            {
                                            	return 0;
                                            }
                                            else
                                            {
                                            	return 6;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if (y <= 46)
                {
                    if (v > 57)
                    {
                    	return 6;
                    }
                    else
                    {
                        if (y <= 27)
                        {
                        	return 6;
                        }
                        else
                        {
                            if (u > 82)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (u <= 79)
                                {
                                	return 6;
                                }
                                else
                                {
                                    if (y > 35)
                                    {
                                    	return 6;
                                    }
                                    else
                                    {
                                        if (u <= 81)
                                        {
                                        	return 0;
                                        }
                                        else
                                        {
                                            if (y <= 30)
                                            {
                                            	return 6;
                                            }
                                            else
                                            {
                                            	return 0;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    if (v <= 59)
                    {
                        if (u <= 86)
                        {
                            if (v > 58)
                            {
                            	return 4;
                            }
                            else
                            {
                                if (y <= 52)
                                {
                                	return 6;
                                }
                                else
                                {
                                    if (u <= 79)
                                    {
                                    	return 4;
                                    }
                                    else
                                    {
                                        if (u <= 85)
                                        {
                                        	return 6;
                                        }
                                        else
                                        {
                                        	return 4;
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (y <= 55)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (u > 96)
                                {
                                	return 6;
                                }
                                else
                                {
                                    if (y > 57)
                                    {
                                    	return 4;
                                    }
                                    else
                                    {
                                        if (u > 93)
                                        {
                                        	return 6;
                                        }
                                        else
                                        {
                                            if (y <= 56)
                                            {
                                            	return 4;
                                            }
                                            else
                                            {
                                            	return 6;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (u > 95)
                        {
                        	return 6;
                        }
                        else
                        {
                            if (v > 64)
                            {
                            	return 6;
                            }
                            else
                            {
                                if (u <= 89)
                                {
                                	return 4;
                                }
                                else
                                {
                                    if (y <= 52)
                                    {
                                    	return 6;
                                    }
                                    else
                                    {
                                    	return 4;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        else
        {
            if (u <= 81)
            {
                if (y <= 75)
                {
                    if (u <= 80)
                    {
                    	return 8;
                    }
                    else
                    {
                        if (v <= 54)
                        {
                        	return 4;
                        }
                        else
                        {
                        	return 8;
                        }
                    }
                }
                else
                {
                    if (v > 54)
                    {
                    	return 4;
                    }
                    else
                    {
                        if (y <= 99)
                        {
                        	return 8;
                        }
                        else
                        {
                        	return 4;
                        }
                    }
                }
            }
            else
            {
                if (u > 100)
                {
                	return 6;
                }
                else
                {
                    if (y > 66)
                    {
                    	return 4;
                    }
                    else
                    {
                        if (v <= 56)
                        {
                            if (u <= 92)
                            {
                                if (u <= 85)
                                {
                                	return 4;
                                }
                                else
                                {
                                    if (v <= 54)
                                    {
                                    	return 0;
                                    }
                                    else
                                    {
                                        if (u > 89)
                                        {
                                        	return 4;
                                        }
                                        else
                                        {
                                            if (u <= 86)
                                            {
                                            	return 0;
                                            }
                                            else
                                            {
                                                if (y <= 60)
                                                {
                                                	return 0;
                                                }
                                                else
                                                {
                                                    if (y <= 63)
                                                    {
                                                    	return 4;
                                                    }
                                                    else
                                                    {
                                                    	return 0;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                if (y <= 63)
                                {
                                	return 6;
                                }
                                else
                                {
                                	return 4;
                                }
                            }
                        }
                        else
                        {
                            if (u <= 97)
                            {
                            	return 4;
                            }
                            else
                            {
                                if (y <= 64)
                                {
                                	return 6;
                                }
                                else
                                {
                                	return 4;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
    

}

int main(int argc, char** argv) {
    unsigned char colour;
    //int h, s;
    
    // fill in colour cube
    for (int y = 0; y < CUBE_SIZE; ++y) {
        for (int u = 0; u < CUBE_SIZE; ++u) {
            for (int v = 0; v < CUBE_SIZE; ++v) {

                //h = getH(u, v);
                //s = getS(u, v);

                colour = tree(y, u, v);
                
                printf("%c", colour);
            }
        }
    }
}
