/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _SpecialAction_h_DEFINED
#define _SpecialAction_h_DEFINED

#include <fstream>
#include "../share/PWalkDef.h"  

using namespace std;

struct SpecialAction {

    int numOfSteps;
    int duration;
    int step;
    
    int *posa;

	SpecialAction() {
    	numOfSteps = duration = step = 0;
    	posa = NULL;
	}

	~SpecialAction() {
    	delete(posa);
	}

	void load(const char *filename) {

    	ifstream in(filename);

    	if (in) {
        	in >> numOfSteps;

        	if (numOfSteps > 0) {
            	delete(posa);
            	posa = (int *)(new int[numOfSteps*posaLength]);

            	for (int i = 0; i < numOfSteps; ++i) {
                	for (int j = 0; j < posaLength; ++j) {
                    	in >> posa[i*posaLength+j];
                	}
                	duration += posa[i*posaLength];
            	}
        	}
        	in.close();
    	}
	}

};

/* posa = position array, format (ints):
   duration,
   head tilt, pan, roll,
   right front joint, shoulder, knee,
   left front joint, shoulder, knee,
   right hind joint, shoulder, knee,
   left hind joint, shoulder, knee
*/

#endif //_SpecialAction_h_DEFINED
