/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Last modification background information
 * $Id: ActionProDef.h 1953 2003-08-21 03:51:39Z eileenm $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
**/

#ifndef _ActionProDef_h_DEFINED
#define _ActionProDef_h_DEFINED

enum {
    aaStop       = 's',
    aaStill      = 'x',
    aaTailUp     = 't',
    aaParaWalk   = 'p'  // dp1 forward(cm), dp2 left(cm), // dp3 turn counterclockwise(deg)
};

// constants for headType
static const int NULL_H	    = 0;
static const int REL_H      = 1; //move head relative to where the head already is
static const int ABS_H	    = 2; //move head relative to where the body is
static const int ABS_PT     = 3; // move head relative to body with pan then tilt
static const int ABS_XYZ    = 4; // move head relative to point on ground under neck in XYZ coords
/*
// constants for headType
static const int headNULL   = 0;
static const int headREL    = 1;
static const int headABS    = 2;

// constants for walkType
static const int walkNORMAL = 0;
static const int walkEDGE   = 1;
static const int walkKICK   = 2;
static const int walkGRAB   = 3;
*/

// for actionSuccess
static const int execFAIL	= 0;
static const int execHEAD	= 1;
static const int execLEGS	= 2;
static const int execALL		= 3;


struct AtomicAction {
    long cmd;
    long param1;
    long param2;
    long param3;
                                    // parameters for parameterised walks
    int walkType;
    double Forward;
    double Left;
    double turnCCW;
    int speed;
    double hF;
    double hB;
    double hdF;
    double hdB;
    double ffO;
    double fsO;
    double bfO;
    double bsO;
    int headType;
    double panx;
    double tilty;
    double nullz;
                                // end parameters for para walk

    long step;			// internal state
    bool finished;
/*
    void Print () {
        cout << "Command " << ((char) (cmd >> 24)) << ((char) (cmd >> 16))
             << ((char) (cmd >> 8)) << ((char) (cmd)) << " params " 
             << param1 << " and " << param2 << endl;
    }


    void Print2() const {
        cout <<
        walkType << " " <<
        Forward << " " <<
        Left << " " <<
        turnCCW << " " <<
        speed << " " <<
        hF << " " <<
        hB << " " <<
        hdF << " " <<
        hdB << " " <<
        ffO << " " <<
        fsO << " " <<
        bfO << " " <<
        bsO << " " <<
        headType << " " <<
        tilty << " " <<
        panx << " " <<
        nullz << endl;
    }
*/
};

#endif // _ActionProDef_h_DEFINED
