/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Last modification background information
 * $Id: CommonSense.h 1953 2003-08-21 03:51:39Z eileenm $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
 * contains basic (but more advanced than those in common.h) utilities for the robots
 * involves the robot sensors
 *
**/


#ifndef CommonSense_h_DEFINED
#define CommonSense_h_DEFINED

/*
#include <OPENR/ODataFormats.h>
#include <OMWares/OMGsensorData.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserverVector.h>
#include <OPENR/OPENREvent.h>
#include <OPENR/OPENRAPI.h>
*/
#include "../share/Common.h"

typedef class OObserver OObserverVector;
class ONotifyEvent;

typedef enum {
    NotFallenFS,
    FallenSideFS,
    FallenFrontFS,
    FallenRearFS
} FallState;

enum switches {
    switch_CHIN = 0,
    switch_FL_PALM = 1,
    switch_RL_PALM = 2,
    switch_FR_PALM = 3,
    switch_RR_PALM = 4,
    switch_BACK = 5,
    NUM_SWITCHES = 6
};

struct SensorSwitch {
    bool state;
    int count;

    void Update (long state_) {
        if (state_ > 0)
        {
            count++;
            state = true;
        }
        else
        {
            count = 0;
            state = false;
        }
    }
};

static const int press_HEAD_FRONT = 0;
static const int press_HEAD_BACK = 1;
static const int NUM_PRESSES = 2;

struct SensorPress {
    long pressure;
    long threshold;
    int count;

    void SetThreshold (long threshold_) {
        threshold = threshold_;
        count = -24;
    }
    void Update (long pressure_) {
        pressure = pressure_;

        if (pressure > threshold)
            count++;
        else
            count = 0;
    }
};

// Enumeration for sensor values
enum {
    ssHEAD_PITCH = 0,
    ssHEAD_YAW = 1,
    ssHEAD_ROLL = 2,
    ssHEAD_PRESS_H = 3,
    ssHEAD_PRESS_F = 4,
    ssINFRARED = 5,
    ssMOUTH = 6,
    ssCHIN_SENSOR = 7,
    ssFL_ROTATOR = 8,
    ssFL_ABDUCTOR = 9,
    ssFL_KNEE = 10,
    ssFL_PALM = 11,
    ssRL_ROTATOR = 12,
    ssRL_ABDUCTOR = 13,
    ssRL_KNEE = 14,
    ssRL_PALM = 15,
    ssFR_ROTATOR = 16,
    ssFR_ABDUCTOR = 17,
    ssFR_KNEE = 18,
    ssFR_PALM = 19,
    ssRR_ROTATOR = 20,
    ssRR_ABDUCTOR = 21,
    ssRR_KNEE = 22,
    ssRR_PALM = 23,
    ssTAIL_H = 24,
    ssTAIL_V = 25,
    ssTHERMO = 26,
    ssBACK_PRESS = 27,
    ssACCEL_FOR = 28,
    ssACCEL_SIDE = 29,
    ssACCEL_Z = 30
};
static const int NUM_SENSORS = 31;

typedef enum {
    hpDEMOBILIZE = 0,
    hpLOCALIZE = 1,
    hpMOBILIZE = 2
}
HeadPressState;

const int NUM_HEADPRESS_STATES = 3;

class CommonSense {

public:

    CommonSense ();
    ~CommonSense () { }
    void ResultSensor (const ONotifyEvent &);
    double robotRelativeForPSD (double, double, double);
    void resetFallenState();

    OObserverVector *oSensor, *oGSensor;

    long sensorFrame;
    long sensorVal[NUM_SENSORS];
    FallState hasFallen;
    double range2obstacle;
    SensorSwitch switch_sensor[NUM_SWITCHES];
    SensorPress press_sensor[NUM_PRESSES];
    
    int fallenBack, fallenRear, fallenRight, fallenLeft, fallenFront;
};

#endif // CommonSense_h_DEFINED

